function annoteAllImageFiles(path)
    fileList = dir(path);
    for i=1:length(fileList);
        if(fileList(i).isdir)
            if(strcmp(fileList(i).name,'.') || strcmp(fileList(i).name,'..'))
                continue;
            end
            annoteAllImageFiles(strcat(path,'/',fileList(i).name));
        else
            imagePath = strcat(path,'/',fileList(i).name);
            disp(imagePath);
            objectArray = read_annotation_xml(imagePath);

            I = imread(imagePath);
            J = I;

            for obj=1:length(objectArray)
               polygon = zeros(length(objectArray(obj).Polygon(:)),1,'int64');
               xCoords = objectArray(obj).Polygon(:,1);
               yCoords = objectArray(obj).Polygon(:,2);
               xCenter = mean([max(xCoords),min(xCoords)]);
               yCenter = mean([max(yCoords),min(yCoords)]);
               polygon(1:2:end) = int64(xCoords);
               polygon(2:2:end) = int64(yCoords);
               J = insertShape(J,'polygon',polygon','Color','red');
               J = insertText(J,[ xCenter, yCenter  ],objectArray(obj).Name,'FontSize',10,'AnchorPoint','Center');
               objectImageName = strrep(fileList(i).name,'.jpg',strcat(num2str(obj),'.jpg'));
               saveROI(I,objectArray(obj).Polygon,objectArray(obj).Name,objectImageName);
            end

%             imshow(J);
%             waitforbuttonpress;
%             close all;
        end
    end
end

