function extractPolygons(path,dataFilePath)
    fileList = dir(path);
    dataFile = fopen(dataFilePath,'at');
    parfor i=1:length(fileList);
        if(fileList(i).isdir)
            if(strcmp(fileList(i).name,'.') || strcmp(fileList(i).name,'..'))
                continue;
            end
            extractPolygons(strcat(path,'/',fileList(i).name),dataFilePath);
        else
            imagePath = strcat(path,'/',fileList(i).name);
            disp(imagePath);
            try
                objectArray = read_annotation_xml(imagePath);
            catch
                continue;
            end

            for obj=1:length(objectArray)
               xCoords = objectArray(obj).Polygon(:,1);
               yCoords = objectArray(obj).Polygon(:,2);
               perimeter = 0;
               for v=1:length(xCoords)
                   if(v == 1)
                       perimeter = sqrt((xCoords(end)-xCoords(1))^2 + (yCoords(end)-yCoords(1))^2);
                   else
                       perimeter = perimeter + sqrt((xCoords(v)-xCoords(v-1))^2 + (yCoords(v)-yCoords(v-1))^2);
                   end
               end
               area = polyarea(xCoords,yCoords);
               dataStr = strcat(lower(objectArray(obj).Name),';',num2str(perimeter),';',num2str(area),';',num2str(length(xCoords)));
               fprintf(dataFile,'%s\n',dataStr);
               
            end
            
            %movefile(imagePath,strrep(imagePath,'Images2','Images'));
        end
    end
    fclose(dataFile);
end

