function [ dataStr ] = image_features( imagePath, objectName )
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

            dataStr = '';
            
            %% Gradient- and intensity features
            I = rgb2gray(imread(imagePath));
            if(isempty(I))
                return;
            end
            [f,~] = vl_sift(single(I));
            SIFTcount = size(f,2);
            Imask = I(find(I(:) ~= 0));
            if(isempty(Imask))
                return;
            end
            contrast = max(Imask) / min(Imask);
            intensityMean = mean(Imask);
            intensityVar = var(single(Imask));
            aspectRatio = size(I,1) / size(I,2);
            [ GradMag, GradDir ] = imgradient(I);
            GradMagBins = hist(GradMag(:),10);
            GradDirBins = hist(GradDir(:),10);
            weightedGradDirBins = hist(GradDir(:).*GradMag(:),10);
            intensityBins = hist(single(Imask),10);
            siftScaleBins = hist(f(3,:),10);
            siftOrientationBins = hist(f(4,:),10);
            [linearityBins, nonRandomness ] = linearity_detector(I);
            
            % Normalize bins to sum=1
            GradMagBins = GradMagBins / sum(GradMagBins);
            GradDirBins = GradDirBins / sum(GradDirBins);
            weightedGradDirBins = weightedGradDirBins / sum(weightedGradDirBins);
            intensityBins = intensityBins / sum(intensityBins);
            siftScaleBins = siftScaleBins / sum(siftScaleBins);
            siftOrientationBins = siftOrientationBins / sum(siftOrientationBins);
            
            % Normalize direction
            [~, idx] = max(GradDirBins);
            GradDirBins = GradDirBins([ idx:10, 1:(idx-1) ]);
            [~, idx] = max(weightedGradDirBins);
            weightedGradDirBins = weightedGradDirBins([ idx:10, 1:(idx-1) ]);
            
            %% Detect lines
%             BW = edge(Igray,'canny');
%             [H,T,R] = hough(BW);
%             P  = houghpeaks(H,5,'threshold',ceil(0.3*max(H(:))));
%             lines = houghlines(BW,T,R,P,'FillGap',20,'MinLength',10);
%             max_len = 0;
%             for k = 1:length(lines)
%                xy = [lines(k).point1; lines(k).point2];
%                plot(xy(:,1),xy(:,2),'LineWidth',2,'Color','green');
% 
%                % Plot beginnings and ends of lines
%                plot(xy(1,1),xy(1,2),'x','LineWidth',2,'Color','yellow');
%                plot(xy(2,1),xy(2,2),'x','LineWidth',2,'Color','red');
% 
%                % Determine the endpoints of the longest line segment
%                len = norm(lines(k).point1 - lines(k).point2);
%                if ( len > max_len)
%                   max_len = len;
%                end
%             end
            
            
            dataStr = strcat(objectName,';');
            for c1=1:length(GradMagBins)
                dataStr = strcat(dataStr,num2str(GradMagBins(c1)),';');
            end
            for c1=1:length(GradDirBins)
                dataStr = strcat(dataStr,num2str(GradDirBins(c1)),';');
            end
            for c1=1:length(weightedGradDirBins)
                dataStr = strcat(dataStr,num2str(weightedGradDirBins(c1)),';');
            end
            for c1=1:length(intensityBins)
                dataStr = strcat(dataStr,num2str(intensityBins(c1)),';');
            end
            for c1=1:length(siftScaleBins)
                dataStr = strcat(dataStr,num2str(siftScaleBins(c1)),';');
            end
            for c1=1:length(siftOrientationBins)
                dataStr = strcat(dataStr,num2str(siftOrientationBins(c1)),';');
            end
            for c1=1:length(linearityBins)
                dataStr = strcat(dataStr,num2str(linearityBins(c1)),';');
            end
            for c1=1:length(nonRandomness)
                dataStr = strcat(dataStr,num2str(nonRandomness(c1)),';');
            end
            dataStr = strcat(dataStr,num2str(aspectRatio),';');
            dataStr = strcat(dataStr,num2str(contrast),';');
            dataStr = strcat(dataStr,num2str(SIFTcount),';');
            %dataStr = strcat(dataStr,num2str(nonRandomness),';');
            dataStr = strcat(dataStr,num2str(intensityMean),';');
            dataStr = strcat(dataStr,num2str(intensityVar));

end

