function [ featureMatrix ] = manmade_feature_extraction( imagePath, I )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
            warning('off','all');

            featureMatrix = zeros(1,4);

           %% Gradient- and linearity features
            if(nargin < 2)
                I = rgb2gray(imread(imagePath));
            end
            if(isempty(I))
                return;
            end
            
            [ GradMag, GradDir ] = imgradient(I);
            GradMagBins = hist(GradMag(:),10);
            weightedGradDirBins = hist(GradDir(:).*GradMag(:),10);
            [ linearityBins, ~ ] = linearity_detector(I);
            
            % Normalize bins to sum=1
            GradMagBins = GradMagBins / sum(GradMagBins);
            weightedGradDirBins = weightedGradDirBins / sum(weightedGradDirBins);
            
            % Normalize direction
            [~, idx] = max(weightedGradDirBins);
            weightedGradDirBins = weightedGradDirBins([ idx:10, 1:(idx-1) ]);
            
            featureMatrix = [   linearityBins(1),...
                                GradMagBins(10),...
                                weightedGradDirBins(9),...
                                weightedGradDirBins(1) ];

end

