%% DESCRIPTION
% Load video sequences from mat-files or create a smaller video from the
% original sequence.
% Mode 1:   Load full zelotypia 1min. and build a smaller version
% Mode 2:   Load full sized "Bang you're dead" video and build a smaller
% video sequence
% Mode 3:   Load 2x downsampled "Bang you're dead" video sequence
% Mode 4:   Load 4x downsampled "Bang you're dead" video sequence


mode = 1;

if(mode == 1)
    load('/home/jan/Videoklip/speciale/zelotypia-1min-frames.mat');
elseif(mode == 2)
    load('/home/jan/Videoklip/speciale/bang_youre_dead_frames_gray.mat');
elseif(mode == 3)
    load('/home/jan/Videoklip/speciale/bang_youre_dead_frames_small_gray.mat');
    nFrames = length(small_mov);
    return;
elseif(mode == 4)
    load('/home/jan/Videoklip/speciale/bang_youre_dead_downsample4_frames.mat');
    nFrames = length(small_mov);
    return;
end

if(mode == 1 || mode == 2)
    nFrames = length(mov);
    top = 83;
    bottom = 576-82;
    movWidth = 1024;
    movHeight = bottom-top+1;
end
if(mode == 2)
    top = 1;
    bottom = size(mov(1).cdata,1);
    movWidth = size(mov(1).cdata,2);
    movHeight = bottom-top+1;
end
downsampling = 2;

smallWidth = floor(movWidth / downsampling);
smallHeight = floor(movHeight / downsampling);

if(mode == 5)
    lastFrame = 960;
    nFrames = 960;
else
    lastFrame = nFrames;
end

small_mov(1:lastFrame) = struct('cdata',zeros(smallHeight, smallWidth, 'uint8'),...
                            'colormap', []);

for i=1:lastFrame
    if(size(mov(1).cdata,3) > 1)
        small_mov(i).cdata = rgb2gray(mov(i).cdata(top:downsampling:bottom,1:downsampling:movWidth,:));
    else
        small_mov(i).cdata = mov(i).cdata(top:downsampling:bottom,1:downsampling:movWidth,:);
    end
    minI = min(small_mov(i).cdata(:));
    small_mov(i).cdata = small_mov(i).cdata - minI;
    maxI = max(small_mov(i).cdata(:));
    maxD = cast(maxI,'double');
    small_mov(i).cdata = small_mov(i).cdata .* (255 / maxD);
end

[ smallHeight, smallWidth,~ ] = size(small_mov(1).cdata);
%targetFrameRate = 8;

% Size a figure based on the video's width and height.
%hf = figure;
%set(hf, 'position', [0 0 smallWidth smallHeight]);

% Play back the movie once at the video's frame rate.
%movie(hf, small_mov, 1, targetFrameRate);