function colorhistograms(I,bins)
%SUMMARY Plot the intensity- or color-histogram of an image.
%I     Image
%bins     bin count for histograms

    figure();
    if(size(I,3) == 1)
        % Intensity histograms
        intensityElements = hist(I(:),bins);
        plot(intensityElements,'k');
        title('Intensity histogram');
    elseif(size(I,3) == 3)
        % Color histograms
        redLayer = cast(I(:,:,1),'double');
        greenLayer = cast(I(:,:,2),'double');
        blueLayer = cast(I(:,:,3),'double');
        redElements = hist(redLayer(:),bins);
        greenElements = hist(greenLayer(:),bins);
        blueElements = hist(blueLayer(:),bins);

        plot(redElements,'red');
        hold on;
        plot(greenElements,'Color',[ 0 0.3 0]);
        plot(blueElements,'blue');
        hold off;
    else
       % An image has either 1 color layer (grayscale) or 3 (RGB-color).
       % Anything else cannot be represented by this function.
       disp('ERROR: Not a valid image'); 
    end
end
    