close all;
if(~exist('small_mov','var'))
    clear all;
    run('../copy_movie_to_smaller_array.m');
end
% run('/home/jan/dtu/speciale/matlab/vlfeat-0.9.18/toolbox/vl_setup');
run('../plot_settings.m');
addpath('..');

probePointsXcount = 30;%size(small_mov(1).cdata,2);
probePointsYcount = 30;%size(small_mov(1).cdata,1);

diffThreshold = 20;
cutThreshold = 0.4*probePointsXcount*probePointsYcount;

%% Perform cut detection
trueCuts = [ 188, 208, 225, 261, 296, 333, 374, 387, 410, 427, 442, 479, 500, 567, 589, 613, 628, 649, 662, 673, 694, 698, 739, 756, 771, 805, 819, 832, 841, 854, 945, 1159, 1206, 1503, 1607, 2122, 2208, 2356, 2435, 2523, 2567, 2593, 2607, 2628, 2658, 2692, 2724, 2750, 2784, 2805, 2937 ];
tic;
[ cutsDetectedDifference, cutsDifference, diffdata, aboveThresholdArray] = cut_detection(small_mov, probePointsXcount, probePointsYcount, ...
                        diffThreshold, cutThreshold );
toc;
truePositives = sum(ismember(cutsDifference,trueCuts));
precision = truePositives / length(cutsDifference)
recall = truePositives / length(trueCuts)
[ cutsAdaptive, cutsDetectedAdaptive ] = cut_detection_frame_distance(aboveThresholdArray,0.4);
truePositives = sum(ismember(cutsAdaptive,trueCuts));
precision = truePositives / length(cutsAdaptive)
recall = truePositives / length(trueCuts)

reportPlot('line','Intensity difference',...
        2:nFrames,'#Frame',....
        [ aboveThresholdArray, ones(nFrames-1,1)*cutThreshold ],'Pixels above Th_d');
legend('Frame difference','Threshold');
return;

%% Determine best thresholds
trueCuts = [ 16, 67, 137, 187, 244, 272, 347, 399, 416 ];
F1score = zeros(20,1);
for i=1:20
    cutThreshold = 0.05*i*probePointsXcount*probePointsYcount;
    [ cutDetected, cuts, diffdata, aboveThresholdArray ] = cut_detection(small_mov, probePointsXcount, probePointsYcount, ...
                        diffThreshold, cutThreshold );
    truePositives = sum(ismember(cuts,trueCuts));
    precision = truePositives / length(cuts);
    recall = truePositives / length(trueCuts);
    F1score(i) = 2*precision*recall / (precision + recall);
end
figure, plot(0.05:0.05:1,F1score,'r*-'); title('Cut threshold');

F1score = zeros(20,1);
for i=1:20
    cutThreshold = 0.05*i;
    [ cuts, cutsDetected ] = cut_detection_frame_distance(aboveThresholdArray,cutThreshold);
    truePositives = sum(ismember(cuts,trueCuts));
    precision = truePositives / length(cuts);
    recall = truePositives / length(trueCuts);
    F1score(i) = 2*precision*recall / (precision + recall);
end
figure, plot(0.05:0.05:1,F1score,'r*-'); title('Adaptive threshold');
%csvwrite('small_mov_sign_data.csv',diffdata);

