function [ signature ] = frame_signature( frame )
%UNTITLED Summary of this function goes here
%   Signature:  1st row -> mean
%               2nd row -> variance

signature = zeros(2,4); 

[ vidHeight, vidWidth ] = size(frame(:,:,1));

midHeight = floor(vidHeight / 2);
midWidth = floor(vidWidth / 2);

sampleCount = 100;

valueMatrix = zeros(sampleCount,4);
indexVector = ones(4,1);
while(min(indexVector) <= sampleCount)
   posX = cast(ceil(rand * vidWidth),'uint32');
   posY = cast(ceil(rand * vidHeight),'uint32');
   
   index = 1;
   if(posY <= midHeight && posX <= midWidth)
       index = 1;
   elseif(posY > midHeight && posX <= midWidth)
       index = 2;
   elseif(posY <= midHeight && posX > midWidth)
       index = 3;
   else
       index = 4;
   end
   
   if(indexVector(index) > sampleCount)
       continue;
   end
   
   pixel = frame(posY,posX,:);
   valueMatrix(indexVector(index),index) = mean(pixel,3);
   indexVector(index) = indexVector(index) + 1;
end
signature(1,:) = mean(valueMatrix,1);
signature(2,:) = var(valueMatrix,1);
end

