%clear all;
%copy_movie_to_smaller_array;

lastGrayScale = cast(rgb2gray(small_mov(1).cdata),'double');
bestSettingsMatrix = zeros(nFrames-1,2);

maxXmove = 5;
maxYmove = 5;

for i=2:nFrames
    disp(strcat('Frame ',num2str(i)));
    
    grayScale = cast(rgb2gray(small_mov(i).cdata),'double');
    %diff = abs(grayScale - lastGrayScale);
    %image(diff);
    
    bestX = 0;
    bestY = 0;
    bestDiff = 10e12;
    for x=-maxXmove:maxXmove
        for y=-maxYmove:maxYmove
            diff2 = abs(grayScale((1+maxYmove+y):(smallHeight-maxYmove+y),(1+maxXmove+x):(smallWidth-maxXmove+x)) ...
                    - lastGrayScale((1+maxYmove):(smallHeight-maxYmove),(1+maxXmove):(smallWidth-maxXmove)));
            sumDiff = sum(diff2(:));
            if(sumDiff < bestDiff)
                bestDiff = sumDiff;
                bestX = x;
                bestY = y;
            end
        end
    end
    bestSetting = [ bestX, bestY, bestDiff ]
    bestSettingsMatrix(i-1,:) = [ bestX, bestY ];
    
    lastGrayScale = grayScale;
    %waitforbuttonpress;
end

plot3(1:(nFrames-1),bestSettingsMatrix(:,1),bestSettingsMatrix(:,2));

avgLength = 10;
avgMovement = zeros(nFrames-avgLength,2);

for i=avgLength:(nFrames-1)
   avgMovement(i-avgLength+1,1) = mean(bestSettingsMatrix((i-avgLength+1):i,1));
   avgMovement(i-avgLength+1,2) = mean(bestSettingsMatrix((i-avgLength+1):i,2));
end

figure();
plot3(1:(nFrames-avgLength),avgMovement(:,1),avgMovement(:,2));