function [ cutsDetected, cuts, matchCountMatrix, diffMatchCountMatrix, diffThreshold ] = sift_cutdetection( mov, adaptive, threshold )
%SIFT_CUT_DETECTION Detect cuts based on the number of SIFT-feature matched between
%frames
%   Detailed explanation goes here

run('/home/jan/dtu/speciale/matlab/vlfeat-0.9.18/toolbox/vl_setup');
nFrames = length(mov);
[ smallHeight, smallWidth ] = size(mov(1).cdata);

% motionDirection = zeros(10,2);
% displacement = zeros(nFrames,2);
% displacement(1,:) = [ 0, 0 ];
matchCountMatrix = zeros(nFrames-1,1);
diffMatchCountMatrix = zeros(nFrames-2,1);
diffThreshold = zeros(nFrames-2,1);
cuts = [];
cutsDetected = 0;
histDiffMatrix = zeros(nFrames-1,1);

for i=1:(nFrames-1)
    Ia = single((mov(i).cdata));
    Ib = single((mov(i+1).cdata));
    [fa,da] = vl_sift(Ia);
    [fb,db] = vl_sift(Ib);
   
   [matches, ~ ] = vl_ubcmatch(da,db);
   matchCountMatrix(i) = size(matches,2);
   if(i > 1)
       diffMatchCountMatrix(i-1) = abs(matchCountMatrix(i-1) - matchCountMatrix(i));
   end
   if(adaptive && cutsDetected > 0 && i > 10 && i-cuts(cutsDetected) > 10)
       meanDiff = mean(diffMatchCountMatrix((i-10):(i-2)));
       varDiff = var(diffMatchCountMatrix((i-10):(i-2)));
       diffThreshold(i-1) = 2.5*meanDiff + 3*sqrt(varDiff);
   elseif(i > 1)
       diffThreshold(i-1) = threshold*smallWidth*smallHeight;
   end
   
   histBins = 20;
   histDifference = sum(abs(hist(Ia(:),histBins)-hist(Ib(:),histBins)));
   histDiffMatrix(i) = histDifference;
  if( i > 1 && diffMatchCountMatrix(i-1) > diffThreshold(i-1))%...
%           && histDifference > histBins*0.0125*smallHeight*smallWidth)
      if(cutsDetected == 0 || ...
         (cutsDetected > 0 && i-cuts(cutsDetected) > 1))
           cutsDetected = cutsDetected + 1;
           cuts(cutsDetected) = i + 1;
      end
   end
   
%    [~, perm] = sort(scores, 'descend') ;
%     matches = matches(:, perm) ;
% 
%     motionDirection(1:9,:) = motionDirection(2:10,:);
%     motionDirection(10,:) = median(fa(1:2,matches(1,:))'-fb(1:2,matches(2,:))');
%     displacement(i+1,:) = displacement(i,:) + motionDirection(10,:);
%     if((i > 1 && diffMatchCountMatrix(i-1) > 200) || displacement(i+1,1) > 300 || displacement(i+1,2) > 150)
%         displacement(i+1,:) = [ 0, 0 ];
%     end
    
end

end

