%% DESCRIPTION
% Visualize the hat matrix leverage scores of the data sets used in the
% thesis.

close all;
clear all;

% Set data parameters
n = 1000;   % Observations
p = 2;      % Features (should be 2 for visualization)
distribution = 't'; % For multivariate normal distribution (GA): 'normal'
                    % For multivariate t-distribution (T3 and T1): 't'
degreeOfFreedom = 3;    % T3:   3
                        % T1:   1

[ X, y, beta ] = generate_data(n,p,9,distribution,degreeOfFreedom);

% Calculate hat matrix:
H = X*((X'*X) \ X');
h = diag(H) / p;

% Visualize
leverage_visualization(X,h);