close all;
clear all;

% Full data - Ground truth
% X = rand(1000,2);
% X = X - 0.5;
X = generate_data(1000,2,9,'t',1);
beta0 = [ 0; 1 ; 1 ];
y0 = [ ones(1000,1), X ]*beta0;
p0 = exp(y0) ./ (1+exp(y0));
leverage_visualization(X,p0), colorbar;

% Full data - Predicted
y = (rand(1000,1) > p0) + 1;
figure,scatter(X(:,1),X(:,2),20,y,'LineWidth',3);
betaHat = mnrfit(X,y);
yHat = [ ones(1000,1), X ]*betaHat;
pHat = exp(yHat) ./ (1+exp(yHat));
leverage_visualization(X,pHat), colorbar;

% Half data - Predicted
sample = ceil(1000*rand(50,1));
Xsample = X(sample,:);
ysample = y(sample);
betaHatsample = mnrfit(Xsample,ysample);
yHat = [ ones(1000,1), X ]*betaHatsample;
pHat = exp(yHat) ./ (1+exp(yHat));
leverage_visualization(X,pHat), colorbar;

[ beta0, betaHat, betaHatsample ]

return;
Xlength = 100;
X = floor(rand(Xlength,2)*diag([ 35, 12 ]));
X(:,1) = X(:,1) - mean(X(:,1));
X(:,2) = X(:,2) - mean(X(:,2));

%y = (X(:,1) > 0).*( X(:,2) > 0)+1;
y = ones(Xlength,1);

H = zeros(Xlength,Xlength);

for i=1:Xlength
    y(i) = 2;
    beta = mnrfit(X,y);
    yhat = [ ones(Xlength,1) X ] * beta;
    yhat = (yhat > 0);
    H(:,i) = yhat;
    y(i) = 1;
end

figure();
scatter(X(:,1),X(:,2),20,250*(y-1));

figure();
imageH = (H-min(H(:)));
imageH = (60/max(imageH(:)))*imageH;
image(imageH);

diagH = diag(H);
summary = [ X diagH ];

figure();
scatter(X(:,1),X(:,2),20,60*diagH);