close all;
clear all;

n = 1000;
p = 2;

X = randn([ n, p ]);
beta = [ 0; ones(p,1) ];
noise = 0.5*randn([ n, 1 ]);

y = [ ones(n,1) X ] * beta + noise;

betaHat = mnrfit(X,(y < 0)+1);
betaHat = betaHat / sum(betaHat.^2);
yhat = [ ones(n,1) X ] * betaHat;

figure();
scatter(X(:,1),X(:,2),20,y>0);
title('Original data');
caxis([ 0 2]);
figure();
scatter(X(:,1),X(:,2),20,yhat>0);
title('Fitted data');
caxis([ 0 2]);


W = zeros(n,n);
for i=1:n
    exponent = [ 1 X(i,:) ] * beta;
    W(i,i) = (1/(1 + exp(exponent))) * (1 - 1/(1 + exp(exponent)));
end
w = diag(W);

figure();
scatter(X(:,1),X(:,2),20,w);
title('w-matrix diagonal');

H = sqrt(W) * X * ((X'*W*X) \ X' * sqrt(W));
h = diag(H);
h = h / sum(h);

figure();
scatter(X(:,1),X(:,2),20,h);
title('hat-matrix diagonal');