function [ moment ] = statistical_moment( Igray, levels, n )
%STATISTICAL_MOMENT Calculate the statistical moment of the gray-levels of a
%grayscale image
%   Detailed explanation goes here

zMean = mean(Igray(:));
[ height, width ] = size(Igray);
pixelCount = height*width;
moment = 0;
for i=0:levels-1
    zi = find(Igray == i);
    ziPart = length(zi) / pixelCount;
    moment = moment + ziPart*(i-zMean)^n;
end
end

