%% DESCRIPTION
% This script extracts a random patch of fixed size from a frame and uses
% SIFT-features to detect its presence in the next frame.

close all;
if(~exist('small_mov','var'))
    clear all;
    run('../copy_movie_to_smaller_array.m');
end
run('/home/jan/dtu/speciale/matlab/vlfeat-0.9.18/toolbox/vl_setup');

patchWidth = floor(0.1*smallWidth);
patchHeight = floor(0.2*smallHeight);

for frame=1:nFrames-1
    patchPositionX = floor((smallWidth-patchWidth)*rand)+1;
    patchPositionY = floor((smallHeight-patchHeight)*rand)+1;
    
    Ia = (small_mov(frame).cdata);
    Ib = (small_mov(frame+1).cdata);
    patch = Ia(patchPositionY:(patchPositionY+patchHeight),...
                patchPositionX:(patchPositionX+patchWidth));
            
    [ siftDetectorA, siftDescriptorA ] = vl_sift(single(patch));
    [ siftDetectorB, siftDescriptorB ] = vl_sift(single(Ib));
    [ matches, scores ] = vl_ubcmatch(siftDescriptorA,siftDescriptorB);
    siftDetectorB(2,:) = siftDetectorB(2,:) + size(Ia,1);
    
    figure(1);
    imagesc(cat(1,Ia,Ib)), colormap(gray), axis image off;
    rectangle('Position',[ patchPositionX, patchPositionY, patchWidth, patchHeight ],...
                'LineWidth',2,'EdgeColor','r');
    vl_plotframe(siftDetectorB(:,matches(2,:)));
    figure(2);
    scatter(siftDetectorB(1,matches(2,:)),-siftDetectorB(2,matches(2,:)),50,scores,'LineWidth',3), colorbar;
    axis auto;
    waitforbuttonpress;
end