%% DESCRIPTION
% Determine the computation time for SIFT-features and SIFT-matching using
% an imagea at different scales

close all;
clear all;
run('../vlfeat-0.9.18/toolbox/vl_setup.m');
addpath('..');

experiments = 20; % For averaging the results we perform each measurement several times

siftDetectionTime = zeros(20,1);
siftDetectorCount = zeros(20,1);
% Load a really big image (here 10MP)
Ifull = rgb2gray(imread('../../images/new_york_hop.jpeg'));
% Extract a patch used in the SIFT-matching experiments
patch = Ifull(1000:1500,2000:2750);
[ patchDetector, patchDescriptor ] = vl_sift(single(patch));
for pct=1:20
    % Create a resize test-image
    Iresize = single(imresize(Ifull,pct*0.05));
    disp(pct);
    %% SIFT-feature detection
       tic;
       for experiment=1:experiments
          [ siftDetector, siftDescriptor ] = vl_sift(Iresize);
       end
       siftDetectionTime(pct) = toc;
       %% SIFT-matching
%     [ siftDetector, siftDescriptor ] = vl_sift(Iresize);
%     siftDetectorCount(pct) = size(siftDetector,2);
%     tic;
%     for experiment=1:experiments
%         [ matches, scores ] = vl_ubcmatch(patchDescriptor,siftDescriptor);
%     end
%     siftDetectionTime(pct) = toc;
end

reportPlot('plot','SIFT computation time',...
            5:5:100,'Scale (%)',...
            sqrt(siftDetectionTime),'Square root of computation time (s^½)');

% reportPlot('plot','SIFT match computation time',...
%             siftDetectorCount,'SIFT-feature count',...
%             siftDetectionTime,'Computation time (s)');