function [ scenenrVector ] = scenenr( cuts, nFrames )
%SCENENR Return a vector of the scene number for each frame
%   Input:  - cuts, a vector with cuts, returned by detect_cuts
%           - nFrames, length of movie
%   Output: - scenenr, a vector of length nFrames with the scene numbers

    scenenrVector = zeros(nFrames,1);
    scenenrVector(cuts) = 1;
    nr = 1;
    for i=1:nFrames
        if(scenenrVector(i) > 0)
            nr = nr + 1;
        end
        scenenrVector(i) = nr;
    end
end

